package com.huaweicloud.sdk.iot.amqpdemo;

import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;

import com.huaweicloud.sdk.iot.amqpdemo.android.AmqpExample;

public class MainActivity extends AppCompatActivity {
    private EditText connectAddress;

    private EditText connectPort;

    private EditText accessKey;

    private EditText accessCode;

    private EditText instanceId;

    private EditText queueName;

    private EditText clientId;

    private Button connectButton;

    private Button disconnectButton;

    private Button stopRetryButton;

    private TextView recMsgView;

    private Handler handler;

    private View connectLayout;

    private View disconnectLayout;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        initActivityComponent();
        AmqpExample amqpExample = new AmqpExample(this);
        this.connectButton.setOnClickListener(v -> {
            if (amqpExample.connect()) {
                this.handler.post(()-> {
                    connectButton.setVisibility(View.INVISIBLE);
                    Toast.makeText(this, "Connecting...", Toast.LENGTH_LONG).show();
                });
            }
        });
        this.disconnectButton.setOnClickListener(v -> amqpExample.disconnect());
        this.stopRetryButton.setOnClickListener(v -> amqpExample.disconnect());
    }

    private void initActivityComponent() {
        this.handler = new Handler();
        this.connectAddress = findViewById(R.id.editText_amqp_connect_server_address);
        this.connectLayout = findViewById(R.id.connect_layout);
        this.disconnectLayout = findViewById(R.id.disconnect_layout);
        this.connectPort = findViewById(R.id.editText_amqp_connect_server_port);
        this.accessKey = findViewById(R.id.editText_amqp_connect_access_key);
        this.accessCode = (findViewById(R.id.editText_amqp_connect_access_code));
        this.instanceId = findViewById(R.id.editText_amqp_connect_instance_id);
        this.queueName = findViewById(R.id.editText_amqp_queue_name);
        this.clientId = findViewById(R.id.editText_amqp_client_id);
        this.connectButton = findViewById(R.id.bt_amqp_connect);
        this.disconnectButton = findViewById(R.id.bt_amqp_disconnect);
        this.stopRetryButton = findViewById(R.id.bt_amqp_stopRetry);
        this.recMsgView = findViewById(R.id.textView_rec_msg);
    }

    public EditText getConnectAddress() {
        return connectAddress;
    }

    public EditText getConnectPort() {
        return connectPort;
    }

    public EditText getAccessKey() {
        return accessKey;
    }

    public EditText getAccessCode() {
        return accessCode;
    }

    public EditText getInstanceId() {
        return instanceId;
    }

    public EditText getQueueName() {
        return queueName;
    }

    public EditText getClientId() {
        return clientId;
    }

    public Button getConnectButton() {
        return connectButton;
    }

    public Button getDisconnectButton() {
        return disconnectButton;
    }

    public TextView getRecMsgView() {
        return recMsgView;
    }

    public Handler getHandler() {
        return handler;
    }

    public View getConnectLayout() {
        return connectLayout;
    }

    public View getDisconnectLayout() {
        return disconnectLayout;
    }

    public Button getStopRetryButton() {
        return stopRetryButton;
    }
}