package com.huaweicloud.sdk.iot.amqpdemo.handler;

import org.apache.qpid.proton.engine.BaseHandler;
import org.apache.qpid.proton.engine.Event;
import org.apache.qpid.proton.engine.Link;
import org.apache.qpid.proton.engine.Receiver;

public class FlowHandler extends BaseHandler {
    final private int window;

    public FlowHandler(int window) {
        this.window = window;
    }

    private void topUp(Receiver rcv) {
        int delta = window - rcv.getCredit();
        rcv.flow(delta);
    }

    @Override
    public void onLinkLocalOpen(Event evt) {
        Link link = evt.getLink();
        if (link instanceof Receiver) {
            topUp((Receiver) link);
        }
    }

    @Override
    public void onLinkRemoteOpen(Event evt) {
        Link link = evt.getLink();
        if (link instanceof Receiver) {
            topUp((Receiver) link);
        }
    }

    @Override
    public void onLinkFlow(Event evt) {
        Link link = evt.getLink();
        if (link instanceof Receiver) {
            topUp((Receiver) link);
        }
    }

    @Override
    public void onDelivery(Event evt) {
        Link link = evt.getLink();
        if (link instanceof Receiver) {
            topUp((Receiver) link);
        }
    }
}
